<?php

//返回手机短信设置参数
function esms_eReturnSet(){
	global $empire,$dbtbpre;
	$pr=$empire->fetch1("select phmmax,phmdaymax,phmonemax,phmretime,phmlen,phmouttime,phmtog,phmopen,phmern,phmmust,phmreg,phmckst,phmdo,phmckrnd,phmlgtoreg from {$dbtbpre}enewspublicadd".do_dblimit_one());
	return $pr;
}

//检验数量
function esms_eCheckPhmMax($setpr,$phno,$uid,$ip,$fundopr=1){
	global $empire,$dbtbpre;
	if(!$setpr['phmopen'])
	{
		printerror('PhmClose','',$fundopr);
	}
	//清理旧记录
	$doclear=esms_eClearPhmTb();
	if($doclear==1)
	{
		return 1;
	}
	//天总数
	if($setpr['phmdaymax'])
	{
		$cknum=$empire->gettotal("select count(*) as total from {$dbtbpre}enewsphmsg");
		if($cknum>=$setpr['phmdaymax'])
		{
			printerror('PhmDayMax','',$fundopr);
		}
	}
	if(empty($ip))
	{
		$ip=egetip();
	}
	$phno=RepPostVar($phno);
	$uid=(int)$uid;
	$ip=RepPostVar($ip);
	$ckwhere=$uid?"uid='".$uid."'":"addip='".$ip."'";
	//单人总数
	if($setpr['phmonemax'])
	{
		$cknum=$empire->gettotal("select count(*) as total from {$dbtbpre}enewsphmsg where ".$ckwhere);
		if($cknum>=$setpr['phmonemax'])
		{
			printerror('PhmOneMax','',$fundopr);
		}
	}
	//间隔时间
	if($setpr['phmretime'])
	{
		$ckr=$empire->fetch1("select addtime from {$dbtbpre}enewsphmsg where ".$ckwhere." order by id desc".do_dblimit_one());
		if($ckr['addtime'])
		{
			if(time()-$ckr['addtime']<=$setpr['phmretime'])
			{
				printerror('PhmRetime','',$fundopr);
			}
		}
	}
}

//设置表单验证码
function esms_eSetFormKey($varname,$val,$ecms=0){
	global $public_r;
	if(!$public_r['phmckst'])
	{
		return '';
	}
	$pubkeyrnd=$public_r['phmckrnd'];
	$time=time();
	$checkpass=md5('d!,i#g?o,-d-'.md5(md5($varname.'E.C.#M!S^e-'.$val).'-E?m!P.i#_R-e'.$time).$pubkeyrnd.'P#-H!o,m^e-e-c.m.s'.$time);
	$key=$time.','.$checkpass.',EmpireCMS';
	esetcookie($varname,$key,0,$ecms);
}

//检查表单验证码
function esms_eCheckFormKey($varname,$postval,$dopr,$ecms=0){
	global $public_r;
	if(!$public_r['phmckst'])
	{
		return '';
	}
	$postval=trim($postval);
	$pubkeytime=$public_r['phmckst'];
	$pubkeyrnd=$public_r['phmckrnd'];
	$r=explode(',',getcvar($varname,$ecms));
	$cktime=(int)$r[0];
	$pass=$r[1];
	$val=$r[2];
	$time=time();
	if($cktime>$time||$time-$cktime>$pubkeytime)
	{
		printerror('phmOutFKeytime','',$dopr);
	}
	if(empty($postval))
	{
		printerror('phmFailFKey','',$dopr);
	}
	$checkpass=md5('d!,i#g?o,-d-'.md5(md5($varname.'E.C.#M!S^e-'.$postval).'-E?m!P.i#_R-e'.$cktime).$pubkeyrnd.'P#-H!o,m^e-e-c.m.s'.$cktime);
	if('dg'.$checkpass<>'dg'.$pass)
	{
		printerror('phmFailFKey','',$dopr);
	}
}

//清空表单验证码
function esms_eEmptyFormKey($varname,$ecms=0){
	global $public_r;
	if(!$public_r['phmckst'])
	{
		return '';
	}
	esetcookie($varname,'',0,$ecms);
}

//返回表单验证码变量值
function esms_eReturnFormKey($varname){
	global $public_r;
	if(!$public_r['phmckst'])
	{
		return 'empirecms';
	}
	$val=EcmsRandInt(100000,99999999);
	return $val;
}

//返回表单验证码变量名
function esms_eReturnFormKeyVname($mtype){
	if($mtype==1)
	{
		$vname='smsformbind';
	}
	elseif($mtype==2)
	{
		$vname='smsformlogin';
	}
	elseif($mtype==3)
	{
		$vname='smsformreg';
	}
	else
	{
		$vname='smsformbind';
	}
	return $vname;
}

//清理旧记录
function esms_eClearPhmTb(){
	global $empire,$dbtbpre;
	$ret=0;
	$ckr=$empire->fetch1("select addtime from {$dbtbpre}enewsphmsg order by id desc".do_dblimit_one());
	if($ckr['addtime'])
	{
		if(date("Y-m-d")<>date("Y-m-d",$ckr['addtime']))
		{
			do_dbTableClearTbData($dbtbpre.'enewsphmsg');//pgsql
			$ret=1;
		}
	}
	return $ret;
}

//返回验证码
function esms_eReturnPhmKey($setpr,$mtype,$phno){
	$keystr=emorekey_make_password($setpr['phmlen'],$setpr['phmtog']);
	return $keystr;
}

//返回识别码
function esms_eReturnPhmSno($setpr,$mtype,$phno){
	$keystr=emorekey_make_password(22,2);
	$keystr=md5(md5($keystr).date("Y-m-d,H:i:s"));
	return $keystr;
}

//返回验证码组合
function esms_eReturnPhmKeystrTog($mtype,$phno,$key){
	$phno=str_replace('|',',',$phno);
	$key=str_replace('|',',',$key);
	$keystr=$phno.'|'.$mtype.'|'.$key;
	return $keystr;
}

//验证码验证
function esms_eCheckPhmKey($mtype,$phno,$key,$uid,$uname,$fundopr=1){
	global $empire,$dbtbpre;
	$mtype=(int)$mtype;
	$phno=RepPostVar($phno);
	$key=RepPostVar($key);
	$uid=(int)$uid;
	$uname=RepPostVar($uname);
	if(!$phno||!$key)
	{
		printerror('PhmErrorKey','',$fundopr);
	}
	$keystr=esms_eReturnPhmKeystrTog($mtype,$phno,$key);
	$keystr=RepPostVar($keystr);
	$ckr=$empire->fetch1("select * from {$dbtbpre}enewsphmsg where ckkey='".$keystr."'".do_dblimit_one());
	if(!$ckr['phno'])
	{
		printerror('PhmErrorKey','',$fundopr);
	}
	if('dg'.$ckr['phno']!='dg'.$phno)
	{
		printerror('PhmErrorKey','',$fundopr);
	}
	if(date("Y-m-d")<>date("Y-m-d",$ckr['addtime']))
	{
		printerror('PhmErrorKey','',$fundopr);
	}
	//用户
	if($uid)
	{
		if($ckr['uid'])
		{
			if($ckr['uid']!=$uid)
			{
				printerror('PhmErrorKey','',$fundopr);
			}
		}
	}
	//是否超时
	if(time()>$ckr['outtime'])
	{
		printerror('PhmErrorKey','',$fundopr);
	}
	if($ckr['isuse'])
	{
		printerror('PhmErrorKey','',$fundopr);
	}
	return $ckr;
}

//更新已使用
function esms_eUpdatePhmUse($id){
	global $empire,$dbtbpre;
	$id=(int)$id;
	$usetime=time();
	$empire->query("update {$dbtbpre}enewsphmsg set isuse=1,usetime='".intval($usetime)."' where id='".$id."'");
	return $usetime;
}

//写入验证码
function esms_eAddPhm($setpr,$mtype,$phno,$uid,$uname){
	global $empire,$dbtbpre;
	$eret_er=array();
	$eret_er['mtype']=(int)$mtype;
	$eret_er['phno']=RepPostVar($phno);
	$eret_er['uid']=(int)$uid;
	$eret_er['uname']=RepPostVar($uname);
	$eret_er['keystr']=esms_eReturnPhmKey($setpr,$mtype,$phno);
	$ckkey=esms_eReturnPhmKeystrTog($mtype,$phno,$eret_er['keystr']);
	$eret_er['addtime']=time();
	$eret_er['outtime']=$eret_er['addtime']+$setpr['phmouttime'];
	$sendst=1;
	$eret_er['addip']=egetip();
	$eret_er['sno']=esms_eReturnPhmSno($setpr,$mtype,$phno);
	$isuse=0;
	$usetime=0;
	$empire->updatesql("insert into {$dbtbpre}enewsphmsg(ckkey,phno,mtype,uid,uname,addtime,outtime,sendst,addip,sno,isuse,usetime) values('$ckkey','".$eret_er['phno']."','".$eret_er['mtype']."','".$eret_er['uid']."','".$eret_er['uname']."','".$eret_er['addtime']."','".$eret_er['outtime']."','$sendst','".$eret_er['addip']."','".$eret_er['sno']."','$isuse','$usetime');","ins");
	$lastid=$empire->lastid($dbtbpre.'enewsphmsg','id');
	//返回
	$eret_er['id']=$lastid;
	return $eret_er;
}

//发送手机验证码
function esms_eSendPhm($mtype,$phno,$uid,$uname,$fundopr=1){
	global $empire,$dbtbpre,$public_r;
	//是否关闭
	if(!$public_r['phmopen'])
	{
		printerror('PhmClose','',$fundopr);
	}
	//配置参数
	$setpr=esms_eReturnSet();
	//检验数量
	$uid=(int)$uid;
	$phno=RepPostVar($phno);
	esms_eCheckPhmMax($setpr,$phno,$uid,'',$fundopr);
	//导入文件
	if(!defined('InEmpireCMSesms'))
	{
		@include_once(ECMS_PATH.'e/extenddef/esms/esmsplus.php');
	}
	if(!function_exists('esms_dosend'))
	{
		echo'Not install esms.';
		exit();
	}
	//写入验证码
	$eret_er=esms_eAddPhm($setpr,$mtype,$phno,$uid,$uname);
	//发送短信
	$esmsr=array();
	$esmsr['send_uid']=$eret_er['uid'];			//用户ID
	$esmsr['send_uname']=$eret_er['uname'];		//用户名
	$esmsr['send_addip']=$eret_er['addip'];		//IP
	$esmsr['send_keysno']=$eret_er['sno'];		//识别码
	$esmsr['send_rid']=$eret_er['id'];			//记录ID
	$esmsr['send_addtime']=$eret_er['addtime'];	//发送时间
	$esmsr['send_outtime']=$eret_er['outtime'];	//过期时间
	$esmsr['send_mtype']=$eret_er['mtype'];		//事件
	$esmsr['send_keystr']=$eret_er['keystr'];	//验证码
	$esmsr['send_phno']=$eret_er['phno'];		//手机号
	$esmsr['send_signname']='';					//短信签名
	$esmsr['send_tempid']='';					//短信模板
	$esmsr['send_sno']='';						//原样返回内容
	$esmsr['send_upcode']='';					//扩展码
	//模板参数
	$esmsr['smstempvar']=array();
	//发送
	$send_result=esms_dosend($esmsr,'GET');
	return $send_result;
}

//验证手机验证码
function esms_eCheckSendPhm($mtype,$phno,$key,$uid,$uname,$fundopr=1){
	global $empire,$dbtbpre,$public_r;
	//是否关闭
	if(!$public_r['phmopen'])
	{
		printerror('PhmClose','',$fundopr);
	}
	//验证
	$eret_er=esms_eCheckPhmKey($mtype,$phno,$key,$uid,$uname,$fundopr);
	//更新状态
	esms_eUpdatePhmUse($eret_er['id']);
	return 'empirecms';
}

//发送短信
function esms_eDoSendPhm($add){
	global $empire,$dbtbpre,$public_r;
	//提示
	$dopr=1;
	if($add['prtype'])
	{
		$dopr=9;
	}
	//是否关闭
	if(!$public_r['phmopen'])
	{
		echo'';
		exit();
	}
	$mtype=(int)$add['smtype'];
	$phno=RepPostVar($add['sphno']);
	$stime=(int)$add['stime'];
	if(!$mtype||!$phno||!$stime)
	{
		echo'';
		exit();
	}
	if(!echphno($phno))
	{
		echo'';
		exit();
	}
	//表单验证码
	$formkey_varname=esms_eReturnFormKeyVname($mtype);
	$formkey_val=$add[$formkey_varname.'na'];
	esms_eCheckFormKey($formkey_varname,$formkey_val,$dopr);
	//time
	$daytime=time();
	if($daytime<$stime||$stime>$daytime+600)
	{
		echo'';
		exit();
	}
	$uid=0;
	$uname='';
	//是否登录
	$emuser=array();
	if($mtype==1)
	{
		$emuser=islogin();
		$uid=$emuser['userid'];
		$uname=$emuser['username'];
	}
	$uid=(int)$uid;
	$uname=RepPostVar($uname);
	//发送
	$result=esms_eSendPhm($mtype,$phno,$uid,$uname);
	echo'ok';
	exit();
}

//显示发送短信按钮
function esms_eShowSendButton($mtype,$vpre='',$btname='',$sec=0){
	global $public_r;
	$mtype=(int)$mtype;
	$sec=(int)$sec;
	if(!$btname)
	{
		$btname='发送验证码';
	}
	if(!$sec)
	{
		$sec=$public_r['phmouttime'];
	}
	//表单验证码
	$formkey_varname=esms_eReturnFormKeyVname($mtype);
?>
<script type="text/javascript">
var ephmcountdown<?=$vpre?>=<?=$sec?>; //设置时间
function ephmsettime<?=$vpre?>(obj)
{
	var emtype;
	var ephno='';
	var eformkey='';
	var eprtype='';
	var timestr='';
	var timestrjs='';
	timestr=new Date().getTime();
	timestrjs=parseInt(timestr/1000)+'';
	emtype=<?=$mtype?>;
	ephno=document.getElementById('esendphmno<?=$vpre?>').value;
	<?php
	if(!$public_r['phmckst'])
	{
	?>
	eformkey=document.getElementById('<?=$formkey_varname?>na<?=$vpre?>').value;
	<?php
	}
	?>
	eprtype=document.getElementById('esendphmprt<?=$vpre?>').value;
	if(ephno=='')
	{
		alert('请输入手机号');
	}
	if(ephmcountdown<?=$vpre?>==0)
	{
		obj.disabled=false;
		obj.value="<?=$btname?>";
		ephmcountdown<?=$vpre?>=<?=$sec?>;
		document.getElementById('esendphmpage<?=$vpre?>').src='<?=$public_r['newsurl']?>e/extenddef/esms/doaction.php?enews=DoSendPhm&smtype='+emtype+'&sphno='+ephno+'&stime='+timestrjs+'&<?=$formkey_varname?>na='+eformkey+'&prtype='+eprtype;
		return;
	}
	else
	{
		obj.disabled=true;
		obj.value="重新发送("+ephmcountdown<?=$vpre?>+")";
		ephmcountdown<?=$vpre?>--;
	}
	setTimeout(function(){ephmsettime<?=$vpre?>(obj)},1000);
}
</script>

  <input type="button" name="esendphmbt<?=$vpre?>" id="esendphmbt<?=$vpre?>" value="<?=$btname?>" onclick="ephmsettime<?=$vpre?>(this)">
  <iframe name="esendphmpage<?=$vpre?>" id="esendphmpage<?=$vpre?>" style="display:none" src="<?=$public_r['newsurl']?>e/extenddef/esms/img/blank.html"></iframe>
<?php
}


//-------------------------------------------- 处理事件 --------------------------------------------

//手机绑定
function esms_eBindPh($add){
	global $empire,$dbtbpre,$public_r;
	//是否登录
	$emuser=islogin();
	//关绑定
	if(strstr($public_r['phmdo'],',bind,'))
	{
		printerror('PhmBindClose','',1);
	}
	//参数
	$uid=(int)$emuser['userid'];
	$uname=RepPostVar($emuser['username']);
	$phno=RepPostVar($add['phno']);
	$phkey=RepPostVar($add['phkey']);
	$doing=(int)$add['doing'];
	//验证验证码
	esms_eCheckSendPhm(1,$phno,$phkey,$uid,$uname);
	//重复
	$num=$empire->gettotal("select count(*) as total from {$dbtbpre}enewsmemberphno where phno='$phno'".do_dblimit_cone());
	if($num)
	{
		printerror('ReBindPhno','',1);
	}
	//写入绑定
	$r=$empire->fetch1("select uname,phno from {$dbtbpre}enewsmemberphno where uid='$uid'");
	if($r['uname'])
	{
		if('dg'.$r['phno']!='dg'.$phno)
		{
			$empire->query("update {$dbtbpre}enewsmemberphno set phno='$phno' where uid='".$uid."'");
		}
	}
	else
	{
		$empire->query("insert into {$dbtbpre}enewsmemberphno(uid,uname,phno) values('$uid','$uname','$phno');");
	}
	//会员状态
	$doupdate='';
	$dh='';
	$doupdate.=$dh.egetmf('mustdo')."=1";
	$dh=',';
	if($public_r['phmern'])
	{
		$doupdate.=$dh.egetmf('isern')."=1";
		$dh=',';
	}
	if($doupdate)
	{
		$msql=$empire->query("update ".eReturnMemberTable()." set ".$doupdate." where ".egetmf('userid')."='$uid'");
	}
	//表单验证码
	$formkey_varname=esms_eReturnFormKeyVname(1);
	esms_eEmptyFormKey($formkey_varname);
	//提示
	printerror('BindPhSuccess','',1);
}

//取消手机绑定
function esms_eDelBindPh($add){
	global $empire,$dbtbpre,$public_r;
	//是否登录
	$emuser=islogin();
	//关取消绑定
	if(strstr($public_r['phmdo'],',delb,'))
	{
		printerror('PhmDelbClose','',1);
	}
	if($public_r['phmern'])
	{
		printerror("ErrorUrl","history.go(-1)",1);
	}
	//参数
	$uid=(int)$emuser['userid'];
	$uname=RepPostVar($emuser['username']);
	$phno=RepPostVar($add['phno']);
	//写入绑定
	$sql=$empire->query("delete from {$dbtbpre}enewsmemberphno where uid='".$uid."'");
	//会员状态
	$doupdate='';
	$dh='';
	$doupdate.=$dh.egetmf('mustdo')."=0";
	$dh=',';
	if($public_r['phmern'])
	{
		$doupdate.=$dh.egetmf('isern')."=0";
		$dh=',';
	}
	if($doupdate)
	{
		$msql=$empire->query("update ".eReturnMemberTable()." set ".$doupdate." where ".egetmf('userid')."='$uid'");
	}
	//提示
	printerror('DelBindPhSuccess','',1);
}

//手机登录
function esms_eBindPhLogin($add){
	global $empire,$dbtbpre,$public_r,$level_r,$ecms_config;
	//关登录
	if(strstr($public_r['phmdo'],',login,'))
	{
		printerror('PhmLoginClose','',1);
	}
	//参数
	$phno=RepPostVar($add['phno']);
	$key=RepPostVar($add['key']);
	$phkey=RepPostVar($add['phkey']);
	//提示
	$dopr=1;
	if($_POST['prtype'])
	{
		$dopr=9;
	}
	if(!$phno||!$phkey)
	{
		printerror('PhmErrorKey','',$dopr);
	}
	if($phno&&!echphno($phno))
	{
		printerror('PhnoFail','',$dopr);
	}
	/*
	//验证码
	$keyvname='checkloginkey';
	if($public_r['loginkey_ok'])
	{
		ecmsCheckShowKey($keyvname,$key,$dopr);
	}
	*/
	//手机是否绑定
	$logintoreg=0;
	$phr=$empire->fetch1("select uid,uname,phno from {$dbtbpre}enewsmemberphno where phno='$phno'".do_dblimit_one());
	$phr['uid']=(int)$phr['uid'];
	if(!$phr['phno']||!$phr['uid'])
	{
		//注册
		if($public_r['phmlgtoreg'])
		{
			$logintoreg=1;
		}
		else
		{
			printerror('PhmNotPhno','',$dopr);
		}
	}
	//验证手机验证码
	esms_eCheckSendPhm(2,$phno,$phkey,0,'',$dopr);
	//注册
	if($logintoreg)
	{
		esms_eBindPhLoginToReg($add);
		exit();
	}
	//登录认证码
	$r=$empire->fetch1("select ".eReturnSelectMemberF('*')." from ".eReturnMemberTable()." where ".egetmf('userid')."='".$phr['uid']."'".do_dblimit_one());
	if(!$r['userid'])
	{
		printerror('PhmErrorKey','',$dopr);
	}
	//默认会员组
	if(empty($r['groupid']))
	{
		$r['groupid']=eReturnMemberDefGroupid();
	}
	$r['groupid']=(int)$r['groupid'];
	if($level_r[$r['groupid']]['loginps'])
	{
		if('dg'.$level_r[$r['groupid']]['loginps']!='dg'.$add['mg_loginps'])
		{
			printerror('FailMgSetPs','',$dopr);
		}
	}
	//未审核
	if($r['checked']==0)
	{
		if($public_r['regacttype']==1)
		{
			printerror('NotCheckedUser','../../member/register/regsend.php',$dopr);
		}
		else
		{
			printerror('NotCheckedUser','',$dopr);
		}
	}
	//登录
	$lifetime=(int)$add['lifetime'];
	DoEcmsMemberLogin($r,$lifetime,1);
	//返回
	$location="../../member/cp/";
	$returnurl=getcvar('returnurl');
	if($returnurl)
	{
		$location=CheckCanUseDm($returnurl);
	}
	if(strstr($_SERVER['HTTP_REFERER'],"e/member/iframe"))
	{
		$location="../../member/iframe/";
	}
	if(strstr($location,"enews=exit")||strstr($location,"e/member/register")||strstr($_SERVER['HTTP_REFERER'],"e/member/register"))
	{
		$location="../../member/cp/";
		$_POST['ecmsfrom']='';
	}
	/*
	ecmsEmptyShowKey($keyvname);//清空验证码
	*/
	$set6=esetcookie("returnurl","");
	//表单验证码
	$formkey_varname=esms_eReturnFormKeyVname(2);
	esms_eEmptyFormKey($formkey_varname);
	//提示
	$location=DoingReturnUrl($location,$_POST['ecmsfrom']);
	printerror("LoginSuccess",$location,$dopr);
}

//手机注册(登录时)
function esms_eBindPhLoginToReg($add){
	global $empire,$dbtbpre,$public_r,$level_r,$ecms_config;
	//提示
	$dopr=1;
	if($add['prtype'])
	{
		$dopr=9;
	}
	//关闭
	if($public_r['register_ok'])
	{
		printerror("CloseRegister","history.go(-1)",$dopr);
	}
	//接口开启
	if(!$public_r['phmopen'])
	{
		printerror('PhmClose','',$dopr);
	}
	//验证时间段允许操作
	eCheckTimeCloseDo('reg');
	//验证IP
	eCheckAccessDoIp('register');
	//关短信注册
	if(!$public_r['phmreg'])
	{
		printerror('PhmRegClose','',$dopr);
	}
	/*
	if(strstr($public_r['phmdo'],',reg,'))
	{
		printerror('PhmRegClose','',$dopr);
	}
	*/
	$reg_r=array();
	$reg_setr=array();
	$rnduname=0;
	//参数
	$groupid=0;
	$phno=RepPostVar($add['phno']);
	$key=RepPostVar($add['key']);
	$phkey=RepPostVar($add['phkey']);
	//随机用户名
	$rnduname=1;
	$rnduname_csr=array();
	$rnduname_csr['phno']=$phno;
	$rnduname_csr['key']=$phkey;
	$rnduname_r=DoEcmsMemberReg_rnduser($rnduname_csr);
	$username=RepPostVar($rnduname_r['reguname']);
	$password=RepPostVar($rnduname_r['regupass']);
	$repassword=$rnduname_r['regupass'];
	if(!$username||!$password)
	{
		printerror('EmptyMember','',$dopr);
	}
	//会员组
	$user_groupid=eReturnMemberDefGroupid();
	$groupid=empty($groupid)?$user_groupid:$groupid;
	$groupid=(int)$groupid;
	$ckmgr=$empire->fetch1("select groupid from {$dbtbpre}enewsmembergroup where groupid='$groupid' and canreg=1");
	if(empty($ckmgr['groupid']))
	{
		printerror('ErrorUrl','',$dopr);
	}
	//验证并注册
	$reg_r['username']=$username;
	$reg_r['password']=$password;
	$reg_r['email']='';
	$reg_r['checked']=1;
	$reg_r['isot']=0;
	$reg_r['phno']=$phno;
	$reg_r['loginnum']=1;
	$reg_r['groupid']=$groupid;
	$reg_r['mg_regps']=$add['mg_regps'];
	//设置
	$reg_setr['ck_gcanreg']=0;
	$reg_setr['ck_setregcheck']=1;
	$reg_setr['ck_reregphno']=0;
	$reg_setr['have_setregbindph']=1;
	$retuserid=DoEcmsMemberReg($reg_r,$reg_setr);
	if($retuserid=='EmptyUsername')//用户名空
	{
		printerror('EmptyMember','',$dopr);
	}
	elseif($retuserid=='GroupNotCanReg')//会员组不支持注册
	{
		printerror('ErrorUrl','',$dopr);
	}
	elseif($retuserid=='FailRegPs')//注册认证码不对
	{
		printerror('FailMgSetPs','',$dopr);
	}
	elseif($retuserid=='FaiUserlen')//用户名长度不对
	{
		printerror('FaiUserlen','',$dopr);
	}
	elseif($retuserid=='FailPasslen')//密码长度不对
	{
		printerror('FailPasslen','',$dopr);
	}
	elseif($retuserid=='NotSpeWord')//用户名包含屏蔽内容
	{
		printerror('NotSpeWord','',$dopr);
	}
	elseif($retuserid=='ReUsername')//用户名重复
	{
		printerror('ReUsername','',$dopr);
	}
	elseif($retuserid=='EmptyEmail')//邮箱为空
	{
		printerror('EmailFail','',$dopr);
	}
	elseif($retuserid=='ReEmail')//邮箱重复
	{
		printerror('ReEmailFail','',$dopr);
	}
	elseif($retuserid=='EmptyPhno')//手机号码为空
	{
		printerror('PhnoFail','',$dopr);
	}
	elseif($retuserid=='RePhno')//手机号码重复
	{
		printerror('RePhnoFail','',$dopr);
	}
	else
	{}
	$userid=(int)$retuserid;
	if(!$userid)
	{
		printerror('ErrorUrl','',$dopr);
	}
	$r=$empire->fetch1("select ".eReturnSelectMemberF('*')." from ".eReturnMemberTable()." where ".egetmf('userid')."='$userid'".do_dblimit_one());
	if(!$r['userid'])
	{
		printerror('ErrorUrl','',$dopr);
	}
	if($r['username']!=$username)
	{
		printerror('ErrorUrl','',$dopr);
	}
	//绑定手机
	$empire->query("insert into {$dbtbpre}enewsmemberphno(uid,uname,phno) values('$userid','$username','$phno');");
	//审核
	if($r['checked']==0)
	{
		$location=DoingReturnUrl("../../../",$_POST['ecmsfrom']);
		printerror("RegisterSuccessCheck",$location,$dopr);
	}
	//登录
	$lifetime=(int)$ecms_config['member']['regcookietime'];
	DoEcmsMemberLogin($r,$lifetime,1);
	//返回
	$location="../../member/cp/";
	$returnurl=getcvar('returnurl');
	if($returnurl)
	{
		$location=CheckCanUseDm($returnurl);
	}
	if(strstr($_SERVER['HTTP_REFERER'],"e/member/iframe"))
	{
		$location="../../member/iframe/";
	}
	if(strstr($location,"enews=exit")||strstr($location,"e/member/register")||strstr($_SERVER['HTTP_REFERER'],"e/member/register"))
	{
		$location="../../member/cp/";
		$_POST['ecmsfrom']='';
	}
	//ecmsEmptyShowKey($keyvname);//清空验证码
	$set6=esetcookie("returnurl","");
	//表单验证码
	$formkey_varname=esms_eReturnFormKeyVname(2);
	esms_eEmptyFormKey($formkey_varname);
	//提示
	$location=DoingReturnUrl($location,$_POST['ecmsfrom']);
	printerror("RegisterSuccess",$location,$dopr);
}

//手机注册
function esms_eBindPhReg($add){
	global $empire,$dbtbpre,$public_r,$level_r,$ecms_config;
	//提示
	$dopr=1;
	if($_POST['prtype'])
	{
		$dopr=9;
	}
	//关闭
	if($public_r['register_ok'])
	{
		printerror("CloseRegister","history.go(-1)",$dopr);
	}
	//接口开启
	if(!$public_r['phmopen'])
	{
		printerror('PhmClose','',$dopr);
	}
	//验证时间段允许操作
	eCheckTimeCloseDo('reg');
	//验证IP
	eCheckAccessDoIp('register');
	//关短信注册
	if(!$public_r['phmreg'])
	{
		printerror('PhmRegClose','',$dopr);
	}
	if(strstr($public_r['phmdo'],',reg,'))
	{
		printerror('PhmRegClose','',$dopr);
	}
	$reg_r=array();
	$reg_setr=array();
	$rnduname=0;
	//参数
	$groupid=(int)$add['groupid'];
	$phno=RepPostVar($add['phno']);
	$key=RepPostVar($add['key']);
	$phkey=RepPostVar($add['phkey']);
	if($public_r['phmreg']==1)
	{
		$username=RepPostVar($add['username']);
		$password=RepPostVar($add['password']);
		$repassword=$add['repassword'];
	}
	else
	{
		$rnduname=1;
		$rnduname_csr=array();
		$rnduname_csr['phno']=$phno;
		$rnduname_csr['key']=$phkey;
		$rnduname_r=DoEcmsMemberReg_rnduser($rnduname_csr);
		$username=RepPostVar($rnduname_r['reguname']);
		$password=RepPostVar($rnduname_r['regupass']);
		$repassword=$rnduname_r['regupass'];
	}
	if(!$username||!$password)
	{
		printerror('EmptyMember','',$dopr);
	}
	if(!$phno||!$phkey)
	{
		printerror('PhmErrorKey','',$dopr);
	}
	if($phno&&!echphno($phno))
	{
		printerror('PhnoFail','',$dopr);
	}
	/*
	//验证码
	$keyvname='checkregkey';
	if($public_r['regkey_ok'])
	{
		ecmsCheckShowKey($keyvname,$key,$dopr);
	}
	*/
	//随机用户名
	if(!$rnduname)
	{
		$reg_setr['ck_userlen']=1;
		$reg_setr['ck_passlen']=1;
		$reg_setr['ck_regcloseuserword']=1;
		if($add['repassword']!==$password)
		{
			printerror('NotRepassword','',$dopr);
		}
		if(!DoEcmsMemberReg_ckunamelen($username))
		{
			printerror('FaiUserlen','',$dopr);
		}
	}
	//会员组
	$user_groupid=eReturnMemberDefGroupid();
	$groupid=empty($groupid)?$user_groupid:$groupid;
	$groupid=(int)$groupid;
	$ckmgr=$empire->fetch1("select groupid from {$dbtbpre}enewsmembergroup where groupid='$groupid' and canreg=1");
	if(empty($ckmgr['groupid']))
	{
		printerror('ErrorUrl','',$dopr);
	}
	//手机是否绑定
	$phr=$empire->fetch1("select uid,uname,phno from {$dbtbpre}enewsmemberphno where phno='$phno'".do_dblimit_one());
	$phr['uid']=(int)$phr['uid'];
	if($phr['phno']||$phr['uid'])
	{
		printerror('PhmRegRePhno','',$dopr);
	}
	//验证手机验证码
	esms_eCheckSendPhm(3,$phno,$phkey,0,'',$dopr);
	//验证并注册
	$reg_r['username']=$username;
	$reg_r['password']=$password;
	$reg_r['email']='';
	$reg_r['checked']=1;
	$reg_r['isot']=0;
	$reg_r['phno']=$phno;
	$reg_r['loginnum']=1;
	$reg_r['groupid']=$groupid;
	$reg_r['mg_regps']=$add['mg_regps'];
	//设置
	$reg_setr['ck_gcanreg']=1;
	$reg_setr['ck_setregcheck']=1;
	$reg_setr['ck_reregphno']=0;
	$reg_setr['have_setregbindph']=1;
	$retuserid=DoEcmsMemberReg($reg_r,$reg_setr);
	if($retuserid=='EmptyUsername')//用户名空
	{
		printerror('EmptyMember','',$dopr);
	}
	elseif($retuserid=='GroupNotCanReg')//会员组不支持注册
	{
		printerror('ErrorUrl','',$dopr);
	}
	elseif($retuserid=='FailRegPs')//注册认证码不对
	{
		printerror('FailMgSetPs','',$dopr);
	}
	elseif($retuserid=='FaiUserlen')//用户名长度不对
	{
		printerror('FaiUserlen','',$dopr);
	}
	elseif($retuserid=='FailPasslen')//密码长度不对
	{
		printerror('FailPasslen','',$dopr);
	}
	elseif($retuserid=='NotSpeWord')//用户名包含屏蔽内容
	{
		printerror('NotSpeWord','',$dopr);
	}
	elseif($retuserid=='ReUsername')//用户名重复
	{
		printerror('ReUsername','',$dopr);
	}
	elseif($retuserid=='EmptyEmail')//邮箱为空
	{
		printerror('EmailFail','',$dopr);
	}
	elseif($retuserid=='ReEmail')//邮箱重复
	{
		printerror('ReEmailFail','',$dopr);
	}
	elseif($retuserid=='EmptyPhno')//手机号码为空
	{
		printerror('PhnoFail','',$dopr);
	}
	elseif($retuserid=='RePhno')//手机号码重复
	{
		printerror('RePhnoFail','',$dopr);
	}
	else
	{}
	$userid=(int)$retuserid;
	if(!$userid)
	{
		printerror('ErrorUrl','',$dopr);
	}
	$r=$empire->fetch1("select ".eReturnSelectMemberF('*')." from ".eReturnMemberTable()." where ".egetmf('userid')."='$userid'".do_dblimit_one());
	if(!$r['userid'])
	{
		printerror('ErrorUrl','',$dopr);
	}
	if($r['username']!=$username)
	{
		printerror('ErrorUrl','',$dopr);
	}
	//绑定手机
	$empire->query("insert into {$dbtbpre}enewsmemberphno(uid,uname,phno) values('$userid','$username','$phno');");
	//审核
	if($r['checked']==0)
	{
		$location=DoingReturnUrl("../../../",$_POST['ecmsfrom']);
		printerror("RegisterSuccessCheck",$location,$dopr);
	}
	//登录
	$lifetime=(int)$ecms_config['member']['regcookietime'];
	DoEcmsMemberLogin($r,$lifetime,1);
	//返回
	$location="../../member/cp/";
	$returnurl=getcvar('returnurl');
	if($returnurl)
	{
		$location=CheckCanUseDm($returnurl);
	}
	if(strstr($_SERVER['HTTP_REFERER'],"e/member/iframe"))
	{
		$location="../../member/iframe/";
	}
	if(strstr($location,"enews=exit")||strstr($location,"e/member/register")||strstr($_SERVER['HTTP_REFERER'],"e/member/register"))
	{
		$location="../../member/cp/";
		$_POST['ecmsfrom']='';
	}
	//ecmsEmptyShowKey($keyvname);//清空验证码
	$set6=esetcookie("returnurl","");
	//表单验证码
	$formkey_varname=esms_eReturnFormKeyVname(3);
	esms_eEmptyFormKey($formkey_varname);
	//提示
	$location=DoingReturnUrl($location,$_POST['ecmsfrom']);
	printerror("RegisterSuccess",$location,$dopr);
}
?>